@import url("https://fonts.googleapis.com/css2?family=Lato&display=swap");
@-webkit-keyframes deleteCard {
  0% {
    transform: translateY(0);
    opacity: 1;
    filter: blur(0);
  }
  100% {
    transform: translateY(100px);
    opacity: 0;
    filter: blur(4px);
  }
}
@keyframes deleteCard {
  0% {
    transform: translateY(0);
    opacity: 1;
    filter: blur(0);
  }
  100% {
    transform: translateY(100px);
    opacity: 0;
    filter: blur(4px);
  }
}
@-webkit-keyframes addCard {
  0% {
    transform: translateX(100px);
    opacity: 0;
    filter: blur(4px);
  }
  100% {
    transform: translateX(0);
    opacity: 1;
    filter: blur(0);
  }
}
@keyframes addCard {
  0% {
    transform: translateX(100px);
    opacity: 0;
    filter: blur(4px);
  }
  100% {
    transform: translateX(0);
    opacity: 1;
    filter: blur(0);
  }
}
@-webkit-keyframes skeletonPulse {
  0% {
    background-color: var(--skeleton-color-light, #ddd);
  }
  100% {
    background-color: var(--skeleton-color-dark, #aaa);
  }
}
@keyframes skeletonPulse {
  0% {
    background-color: var(--skeleton-color-light, #ddd);
  }
  100% {
    background-color: var(--skeleton-color-dark, #aaa);
  }
}
* {
  font-family: "Lato", sans-serif;
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

body {
  background-color: hsl(240deg, 20%, 96%);
}

main {
  overflow: hidden;
  position: relative;
}

header {
  z-index: 100;
  position: relative;
  min-height: 4rem;
  padding: 0.5rem 1rem;
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: white;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.5);
}
header svg {
  fill: black;
  cursor: pointer;
}
header svg:hover {
  fill: #555;
}
header .sidebar {
  z-index: 10;
  position: absolute;
  right: 0;
  top: 100%;
  width: min(25rem, 75vw);
  padding: 1rem;
  background-color: white;
  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.5);
  transform: translateX(100%);
  transition: transform 0.3s ease, opacity 0.3s, display 0s;
  opacity: 0;
}
header .sidebar.js-show {
  transform: translateX(0);
  opacity: 1;
}

.card-grid {
  --card-width: 300px;
  padding: 1rem;
  display: grid;
  align-items: flex-start;
  grid-template-columns: repeat(auto-fit, minmax(var(--card-width), 1fr));
  gap: 1rem;
}

.card {
  --card-hue: 240;
  padding: 1rem;
  border-radius: 0.45rem;
  min-width: var(--card-width);
  background-color: white;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.5);
}
.card .card-header {
  --header-clr: hsl(var(--card-hue), 80%, 30%);
  position: relative;
  width: -moz-fit-content;
  width: -webkit-fit-content;
  width: fit-content;
  margin-bottom: 1rem;
  color: var(--header-clr);
  font-size: 1.17rem;
  font-weight: bold;
  z-index: 2;
}
.card .card-header::after {
  --header-clr-hover: hsl(var(--card-hue), 60%, 85%);
  position: absolute;
  z-index: -1;
  content: "";
  bottom: 0;
  left: 0;
  width: calc(100% + 2ch);
  height: 40%;
  background-color: var(--header-clr-hover);
  opacity: 0;
  transform: scaleX(0);
  transform-origin: left;
  transition: transform 0.2s ease-out, opacity 0.2s;
}
.card .card-footer {
  margin-top: 1rem;
  display: flex;
}
.card .card-button {
  --button-clr: hsl(var(--card-hue), 50%, 70%);
  --button-clr-hover: hsl(var(--card-hue), 50%, 75%);
  --button-clr-active: hsl(var(--card-hue), 50%, 65%);
  padding: 0.5rem;
  border-radius: 0.25rem;
  background-color: var(--button-clr);
  color: white;
  text-transform: capitalize;
  font-weight: bold;
  border: none;
  cursor: pointer;
}
.card .card-button + .card-button {
  margin-left: 1rem;
}
.card .card-button:hover, .card .card-button:focus {
  background-color: var(--button-clr-hover);
}
.card .card-button:active {
  background-color: var(--button-clr-active);
}
.card .card-button.button-outline {
  --button-clr-hover: hsl(var(--card-hue), 50%, 90%);
  --button-clr-active: hsl(var(--card-hue), 50%, 75%);
  border: none;
  background-color: transparent;
  color: initial;
  border: 2px solid var(--button-clr);
}
.card .card-button.button-outline:hover, .card .card-button.button-outline:focus {
  background-color: var(--button-clr-hover);
}
.card .card-button.button-outline:active {
  background-color: var(--button-clr-active);
}
.card:hover .card-header::after {
  opacity: 1;
  transform: scaleX(1);
}
.card.js-create {
  -webkit-animation: 0.4s addCard ease-out;
          animation: 0.4s addCard ease-out;
}
.card.js-destroy {
  -webkit-animation: 0.4s deleteCard ease-out forwards;
          animation: 0.4s deleteCard ease-out forwards;
}

.skeleton {
  --skeleton-color-light: hsl(var(--card-hue, 100), 50%, 55%);
  --skeleton-color-dark: hsl(var(--card-hue, 100), 50%, 45%);
  height: 0.6rem;
  width: 100%;
  margin-block: 0.5rem;
  opacity: 0.7;
  background-color: var(--skeleton-color-dark);
  -webkit-animation: 1s skeletonPulse ease-in-out infinite alternate;
          animation: 1s skeletonPulse ease-in-out infinite alternate;
}
.skeleton:last-of-type {
  width: 90%;
}
.skeleton.skeleton-header {
  width: 15ch;
  height: 0.9rem;
}